/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _ALSA_MIDI_H_
#define _ALSA_MIDI_H_

#include "Plugin.h"
#include "Pollable.h"

#include <alsa/asoundlib.h>

extern Type * AlsaMidi_type;
extern Type * AlsaMidiIn_type;
extern Type * AlsaMidiOut_type;

class AlsaMidi
: public Plugin
{
	public:
		snd_seq_t * handle;
		int client, port, q, direction;
		
	public:
		AlsaMidi (Type * t = AlsaMidi_type, int _flags = 0);
		~AlsaMidi();
		
		void open (char * name, int _direction);
		void subscribe (int major, int minor, bool connect = true);
};

class AlsaMidiIn
: public AlsaMidi,
	public Pollable
{
	public:
		AlsaMidiIn();
		~AlsaMidiIn();
			
		void init (char * name);

		/* Pollable:: */
		virtual void get_pollfd (InstanceList<struct pollfd> & list);
		virtual void do_io();
		virtual operator Object * () { return (Object *) this; }
};

class AlsaMidiOut
: public AlsaMidi
{
	private:
		snd_seq_event_t packet;

	public:
		AlsaMidiOut();

		void init (char * name);

		void send (MidiEvent * e);

		/* Plugin:: */
		virtual void process_time (d_time dt, int clocks);
};

#endif /* _ALSA_MIDI_H_ */
