/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _AUDIO_H_
#define _AUDIO_H_

#include "Plugin.h"

/* AudioClock is an abstraction to make different PCM architectures
 * (currently ALSA, Jack) look the same to a graph. */

class AudioClock
: public Plugin
{
	public:
		/* normally only acquired in the clock's realtime thread. acquired
		 * by the graph on shutdown.
		 */
		Mutex mutex;

		AudioClock (Type * t = AudioClock_type, int _flags = 0)
			: Plugin (t, _flags)
			{ }
		
		/* called before another plugin is inserted into the graph. make sure
		 * there's only one audio clock present. */
		virtual void pre_insert_other (Plugin * p)
			{ 
				if (AudioClock_type->is_derived (p))
					throw RuntimeError() << "an audio clock is already present.";
			}
};

#endif /* _AUDIO_H_ */
