/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _EVENTLIST_H_
#define _EVENTLIST_H_

#include "Event.h"
#include "List.h"
#include "Thread.h"

class EventList
: public NamedObject,
	public TypedObjectList<Event>
{
	public:
		Mutex mutex;
		
		/* the event type the list accepts (will also accept derived events). */
		Type * type; 

		unsigned int color; 
		bool allow_doubles; /* only Note affected */
		bool quiet; /* don't scream	when ignoring a double or an unmatched note-off */

		EventList (Type * t = Event_type, int granularity = 1024);
		EventList (EventList & p, int lo = 0, int hi = -1);
	
		void set_event_type (Type * t);

		int index_of_tick (d_tick t);

		int add_event (Event * e);
		int add_midi_event (MidiEvent * n);
		int add_note_off (MidiEvent * n);
};

template <class E>
class TypedEventList
: public EventList
{
	public:
		TypedEventList<E> (Type * t = Event_type, int granularity = 1024)
			: EventList (t, granularity)
			{ }
		
		E * operator [] (int i)
			{
				return (E *) EventList::operator [] (i);
			}
};

#endif /* _EVENTLIST_H_ */
