/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifdef WITH_IIWU
#ifndef _IIWU_H_
#define _IIWU_H_

#include "Plugin.h"

#include <fluidsynth.h>

class IIWU
: public Plugin
{
	public:
		IIWU();
		~IIWU();

		fluid_synth_t * synth;
		fluid_cmd_handler_t * cmd_handler;

		int sample_rate, voices;
		
		enum {
			Reverb = 1,
			Chorus = 2,
			Verbose = 4,
		};
		int flags;
		
		char * path;
		d_sample gain;

		void open();
		int add_sf2 (char * path);
		
		/* Plugin::* */
		virtual void process_audio (int frames);
		virtual void pre_insert (Graph * g);

		virtual void seek();
		virtual void set_state (Graph *, int);

	protected:
		void parse_event (MidiEvent * e);
		void all_notes_off();

		static void log (int level, char *, void * self);
};

#endif /* _IIWU_H_ */
#endif /* WITH_IIWU */
