/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _LFO_H_
#define _LFO_H_

#include "Graph.h"

#define LFO_WAVE_SIZE	2048

extern Type * LFO_type;

/* a LFO for the Audio cycle. */

class LFO
: public Plugin
{
	protected:
		static d_float default_wave [];

		d_float state;
		d_tick tick;

		void one_cycle (d_tick);
		
	public:
		d_float * wave;
		int points;
		
		/* rate is in ticks/cycle. */
		d_float rate;
		int interpolate;

		LFO();
		~LFO();

		void set_wave (d_float *, int);

		/* Plugin::* */
		virtual void process_audio (int frames);
		virtual void seek();
};

#endif /* _LFO_H_ */
