/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _NOTEOFFS_H_
#define _NOTEOFFS_H_

#include "EventList.h"

class NoteOffs
: public TypedObjectList<MidiEvent>
{
	public:
		NoteOffs()
			: TypedObjectList<MidiEvent> ("note_offs", 12)
			{ }
		
		~NoteOffs()
			{ }

		void push (MidiEvent * e)
			{
				MidiEvent * f = (MidiEvent *) items;
				
				int i = 0;

				for (  ; i < length; ++i, ++f)
					if (f->tick > e->tick)
						break;

				add_object (e, i);
			}

		MidiEvent * peek()
			{
				if (length == 0)
					return 0;

				return (*this) [0];
			}

		MidiEvent * pop()
			{
				MidiEvent * e = peek();

				if (e) remove_items (0, 1);

				return e;
			}

		/* you do not need to call this before ~() */
		void clear()
			{
				for (int i = 0; i < length; ++i)
				{
					MidiEvent * e = (*this)[i];
					::decref (e, true);
					/* FIXME: is this really safe against concurrent access? need to
					 * hold all graph locks. */
					e->return_to_cache();
				}

				length = 0;
			}
};

#endif /* _NOTEOFFS_H_ */
