/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _OGG_FILE_H_
#define _OGG_FILE_H_

#ifdef WITH_OGG

#include "SoundFile.h"

#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>

class OggFile
: public SoundFile
{
	private:
		FILE * f;
		char * path; /* strdup'd */

		OggVorbis_File vf;
		int section;

		ogg_int64_t at, start; /* frame offsets */
		
	public:
		OggFile()
			{
				f = 0;
				at = 0;
				path = 0;
			}

		~OggFile()
			{
				if (f)
					fclose (f);
				ov_clear (&vf);
				if (path)
					free (path);
			}

		void open (char * path);
		
		d_frame tell() 
			{
				return at;
			}

		/* SoundFile:: */
		virtual char * get_path()
			{ 
				return path;
			}

		void read (d_sample **, int frames);

		void seek (d_frame);
};

#endif /* !_OGG_FILE_H_ */

#endif /* WITH_OGG */
