/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _RTCLOCK_H_
#define _RTCLOCK_H_

#include "RTSentinel.h"

/* this clock counts system time. */
class RTClock
: public Plugin,
	public Thread
{
	public:
		int frequency, rtc_fd;

		d_tick tick;
		d_time time, jitter;

		/* polling for requests (wake_up) and the rtc. */
		Poll poll;
		Pipe pulse;

		RTSentinel * sentinel;

		RTClock();
		~RTClock();
		
		void set_frequency (int f);

		/* Plugin:: */
		virtual void wake_up(); /* synthesize a pulse. */

	private:
		void no_rtc();
		virtual void * thread();
};

#endif /* !_RTCLOCK_H_ */
