/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _SCRIPTPLUGIN_H_
#define _SCRIPTPLUGIN_H_

class ScriptPlugin
: public Plugin
{
	private:
		atomic woken;
	
	public:
		/* see PyThreadState_Get()->interp->checkinterval */
		int checkinterval;

		void get_methods();

		ScriptPlugin();
		~ScriptPlugin();

		virtual void wake_up();
		virtual void process_script (Plugin *);

		virtual void process_beat (d_tick until)
			{
				call_method ("process_beat", "(dd)", graph->beat_tick, until);
			}

		virtual void pre_insert (Graph * g)
			{
				if (g->script_scheduler == 0)
					throw RuntimeError() << this << " needs a ScriptScheduler."; 
			}

		virtual void pre_remove_other (Plugin * p)
			{
				if (ScriptScheduler_type->is_derived (p))
					throw RuntimeError() << this << " needs " << p;
			}
};

#endif /* _SCRIPTPLUGIN_H_ */
