/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _STACK_H_
#define _STACK_H_

template <class T>
class Stack
{
	protected:
		int size;
		T * data;
		int top;

	public:
		Stack (int _size)
			{
				size = _size;
				top = 0;
				data = new T [size];
			}

		virtual ~Stack()
			{
				delete [] data;
			}

		int have() { return top; }

		T pop()
			{
				if (top == 0)
				{
					#ifdef DEBUG
					TRAP;
					#endif
					throw AssertionError() << "the stack is empty.";
				}

				return data [--top];
			}
			
		void push (T t)
			{
				if (top == size)
				{
					#ifdef DEBUG
					TRAP;
					#endif
					throw OverflowError() << "the stack is full.";
				}

				data [top++] = t;
			}
};

#endif /* _STACK_H_ */
