#include <string.h>
#include <assert.h>
#include <ctype.h>

#include "basics.h"
#include "String.h"

#define GRAIN	1022

String::String (char * s)
{
	string = (char *) malloc (allocated = GRAIN);
	inflate (length = strlen (s));

	strcpy (string, s);
}

String::~String()
{
	free (string);
}

void
String::inflate (int plus)
{
	//fprintf (stderr, "length %d + %d", length, plus);
	length += plus;

	int a = allocated;
	
	while (allocated < length + 1)
		allocated += GRAIN;

	if (allocated > (1000000))
	{
		fprintf (stderr, "allocation of %d", allocated);
		assert (0);
	}

	if (allocated != a)
		string = (char *) realloc (string, allocated);
}

String::operator char * ()
{
	return string;
}

String & 
String::operator << (unsigned long ul)
{
	char s[32];
	sprintf (s, "%lu", ul);

	return *this << s;
}

String & 
String::operator << (double d)
{
	char s[32];
	sprintf (s, "%.3f", d);

	return *this << s;
}

String & 
String::operator << (int i)
{
	char s[32];
	sprintf (s, "%d", i);

	return *this << s;
}

String & 
String::operator << (const void * v)
{
	char s[32];
	sprintf (s, "%p", v);

	return *this << s;
}

String & 
String::operator << (char b)
{
	char s[32];
	if (isprint (b))
		sprintf (s, "%c", b);
	else
		sprintf (s, "\\x%02x", b);

	return *this << s;
}
String & 
String::operator << (byte b)
{
	char s[32];
	sprintf (s, "\\x%02x", b);
	return *this << s;
}

