/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _TEMPOMAP_H_
#define _TEMPOMAP_H_

#include "EventList.h"

/* the tempo map is protected by the graph mutex. */
class TempoMap
{
	private:
		d_time quarter;	/* ticks / quarter note */
		int current;		/* current event */
		d_time default_sec_per_tick;

	public:
		TypedEventList<TempoEvent> events;
		
		TempoMap();
		~TempoMap();

		void seek_tick (d_tick);
		void seek_time (d_time);

		void recalculate (d_tick quarter);

		void add (d_float bpm, d_tick tick);
		/* remove n tempo events from tick on */
		void remove (d_tick, int n); 

		/* mapping time to ticks and reverse. */
		d_tick time2tick (d_time t)
			{
				return virtual_time2tick (t, t);
			}

		d_time tick2time (d_tick t)
			{
				return virtual_tick2time (t, t);
			}

		/* mapping that is restricted to one tempo zone. */
		d_tick virtual_time2tick (d_time zone, d_time t);
		d_time virtual_tick2time (d_tick zone, d_tick t);
};

#endif /* _TEMPOMAP_H_ */
