/* (c) 2001-4 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _TIMEMAP_H_
#define _TIMEMAP_H_

#include "EventList.h"

class TimeMap
: public NamedObject
{
	public:
		EventList events;
		TimeEvent default_time;

		TimeMap();
		~TimeMap();

		int add (TimeEvent *);
		void remove (TimeEvent *);

		void recalculate();

		TimeEvent * operator [] (int i)
			{
				return (TimeEvent *) events[i];
			}

		/* mapping time to ticks and reverse. */
		d_tick bbt2tick (BBT & bbt);
		void tick2bbt (d_tick t, BBT & bbt);
};

class TimeIter
: public Iterator<TimeEvent *>
{
	public:
		d_tick tick;
		BBT bbt;

		TimeIter (TimeMap *, d_tick);

		TimeIter & operator += (d_tick t);
};

#endif /* _TIMEMAP_H_ */
