/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _ATOMIC_H_
#define _ATOMIC_H_

#include <asm/atomic.h>

class atomic
: public atomic_t
{
	public:
		atomic (int i = 0)
			{
				*this = i;
			}

		inline int operator = (int i)
			{
				return atomic_set (this, i);
			}

		inline operator int()
			{
				return atomic_read (this);
			}
		
		/* prefix increment. */
		inline void operator ++()
			{
				atomic_inc (this);
			}

		/* prefix decrement. */
		inline void operator --()
			{
				atomic_dec (this);
			}

		/* increment and compare to zero. */
		inline bool inc_is_zero()
			{
				return atomic_inc_and_test (this);
			}

		/* decrement and compare to zero. */
		inline bool dec_is_zero()
			{
				return atomic_dec_and_test (this);
			}
};

#endif /* _ATOMIC_H_ */
