#! /usr/bin/env python
import sys, os, time

# make this example runnable in situ (without installing nam.so) 
sys.path += ['.']
from nam import *
import config

graph = Graph()
graph.add (AlsaClock (44100, os.geteuid() and 1024 or 64))

pcm_in = AlsaIn (config.pcm)
pcm_out = AlsaOut (config.pcm)

# add the output 'after' (10. > 5.) so we can feed it from the input
graph.add (pcm_in, 5.) 
graph.add (pcm_out, 10.) 

# prepare the graph for running, configures the audio streams and makes
# their ports available.
graph.state = Plugin.Prepared

# now we can connect:
for i in range (2):
	pcm_in.outs[i].connect (pcm_out.ins[i])

# turn on processing
graph.state = Plugin.Activated

while __name__ == '__main__':
	try: time.sleep (1.)
	except KeyboardInterrupt: raise SystemExit
