#! /usr/bin/env python
import sys, os, time

# make this example runnable in situ (without installing nam.so) 
sys.path += ['.']
from nam import *
import config

graph = Graph()
graph.add (AlsaClock(44100, os.geteuid() and 2048 or 128))

pcm_out = AlsaOut (config.pcm)
graph.add (pcm_out, 10.) 

graph.state = Plugin.Prepared

osc = LadspaPlugin ('analogue_osc_1416.so')
graph.add (osc, 0.)
	
gain = Gain (db = -36, n_outs = 2)
graph.add (gain, 5.)

osc.outs[0].connect (gain.ins[0])
gain.outs[0].connect (pcm_out.ins[0])
gain.outs[1].connect (pcm_out.ins[1])

# turn on processing
graph.state = Plugin.Activated
