#! /usr/bin/env python
import sys, os, time

# make this example runnable in situ (without installing nam.so) 
sys.path += ['.']
from nam import *
import config

graph = Graph()
graph.add (AlsaClock (44100, os.geteuid() and 1024 or 256))

# iiwu synth, 10 voices polyphony, play the marimba, reverb on,
default = (len (sys.argv) == 1)
if default:
	sf2 = os.path.dirname (sys.argv[0]) + '/marimba.sf2'
else:
	sf2 = sys.argv[1]
iiwu = IIWU (10, sf2)
graph.add (iiwu, 5.)
if default:
	iiwu.cmdline ("select 0 0 0 12")
iiwu.gain *= .5

pcm_out = AlsaOut (config.pcm)
graph.add (pcm_out, 10.) 

midi_in = MidiIn (config.midi_in)
graph.add (midi_in)

# prepare the graph for running, configures the audio device
graph.state = Plugin.Prepared

# midi connection
midi_in.outs[0].connect (iiwu.ins[0])

# audio connections
iiwu.outs[0].connect (pcm_out.ins[0])
iiwu.outs[1].connect (pcm_out.ins[1])

# turn on processing
graph.state = Plugin.Activated

