#! /usr/bin/env python
#
# plays a midi file 

import sys, os, time

sys.path += ['.']
from nam import *
import config

from MidiFile import MidiFile
m = MidiFile (sys.argv[1])

graph = Graph (m.quarter)
graph.add (RTClock())

out = MidiOut (config.midi_out)

graph.add (out, 2)

for e in m.tempo:
	if type (e) == TempoEvent:
		graph.store_tempo (e.bpm, e.tick)

for t in m.tracks:
	part = Part (t, name = t.name)
	graph.add (part)
	part.outs[0].connect (out.ins[0])

graph.state = 3
