#! /usr/bin/env python
import sys, os, time

# make this example runnable in situ (without installing nam.so) 
sys.path = ['.',] + sys.path
from nam import *

if len (sys.argv) != 3 or '--help' in sys.argv:
	print "usage:\n%s <alsa-device> <filename>\n" % sys.argv[0]
	raise SystemExit
	
graph = Graph()
graph.add (AlsaClock (44100, 2048))
graph.add (DiskScheduler())

pcm_in = AlsaIn (sys.argv[1])
graph.add (pcm_in, 0.) 

# prepare the graph for running; this configures the audio devices on 
# the graph.
graph.state = Plugin.Prepared

# open argv[1] for writing, two channels, 16 bit resolution
wave = WaveFile (sys.argv[2], 'w', 2, bits = 16)

disk_stream = DiskStream (wave)
graph.add (disk_stream, 5.)

# connect every channel
for i in range (wave.channels):
	pcm_in.outs[i].connect (disk_stream.ins[i])

# turn on processing
graph.state = Plugin.Activated
graph.state = Plugin.Rolling

print "press ^C to stop recording."

while 1:
	try: time.sleep (1.)
	except KeyboardInterrupt: break
