#include <ft2build.h>
#include FT_FREETYPE_H 
#include FT_GLYPH_H

extern Type * FreeType_type;
extern Type * Glyph_type;

class FreeType
: public Object
{
	public:
		FT_Face face;
		FT_UInt last; /* for kerning */
		FT_Matrix transform;
		FT_Vector translate;
		FT_Vector position;

		int size;
		int x, y;
		Color color;
		int alpha;

		FreeType();
		~FreeType();

		void init (char * path, int n);
		
		template <class C> void draw (RGB * rgb, C * text, int n);

		void set_size (int size);
		int get_size();

		void move (float x, float y);
		void rotate (float a);

		void load_glyph (FT_UInt gi);
		void draw_glyph (RGB * rgb, FT_UInt gi);

		/* */

		void copy (RGB * rgb, FT_Bitmap * bitmap, int x, int y);
};

class Glyph
: public Object
{
	public:
		FT_Glyph glyph;

		Glyph()
			{
				glyph = 0;
			}

		~Glyph()
			{
				if (glyph)
					FT_Done_Glyph (glyph);
			}

		void init (FT_Glyph g)
			{
				glyph = g;
			}
	
		FT_Outline & outline()
			{
				if (glyph->format != ft_glyph_format_outline)
					throw AssertionError() << "not an outline glyph";

				return ((FT_OutlineGlyphRec_*) glyph)->outline;
			}
};
