#ifndef _GTK_H_
#define _GTK_H_

#include <basics.h>
#include <Pipe.h>
#include "Thread.h"

#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

extern Type * Gtk_type;

/* extracts a GtkWidget * from a PyObject * (or throws) */
extern GtkWidget * get_widget_from_pygtk (PyObject * arg);
	
/* runs an equivalent to GTK::mainloop() in a separate thread. */
class Gtk
: public Object, Thread
{
	public:
		GMainContext * context;
		bool quitting;

		Gtk();
		~Gtk();

		virtual void * thread();
		static gint poll_func (GPollFD * fds, guint n, gint timeout);
};

/* //////////////////////////////////////////////////////////////////////// */

/* scoped Gtk lock/unlock */
class GtkLock
{
	public:
		GtkLock()
			{
				GDK_THREADS_ENTER();
			}

		~GtkLock()
			{
				GDK_THREADS_LEAVE();
			}
};

class GtkUnlock
{
	public:
		GtkUnlock()
			{
				GDK_THREADS_LEAVE();
			}

		~GtkUnlock()
			{
				GDK_THREADS_ENTER();
			}
};

#endif /* _GTK_H_ */
