/* (c) 2001, 2002 tim goetze <tim@quitte.de> -- see the file 'COPYING.gz'. */

#ifndef _PROFILER_H_
#define _PROFILER_H_

#include "msg.h"

class profiler
{
	public:
		double start;
		double stop;
		char * prefix;
		
		/* a profiler with 0 prefix will never output anything. */
		profiler (char * _prefix = 0)
		{
			prefix = _prefix;
			start = gettimeofday();
		}

		double get()
		{
			return gettimeofday() - start;
		}

		~profiler()
		{
			if (prefix == 0)
				return;

			stop = gettimeofday();

			double d = (double) (stop - start);
			msg(), "dt {", prefix, "} = ", (d * 1000), " ms";
		}
};

#endif /* _PROFILER_H_ */
