#! /usr/bin/env python

import sys, time

name = sys.argv[1]

lines = sys.stdin.readlines()

font = None
char = None
all = { }

def dump_bits (bits):
	s = ""
	for i in range (8):
		s += (bits & (1 << (7 - i))) and " " or "*"
	print >> sys.stderr, s

for line in lines:
	args = line.strip().split()
	op = args[0]

	if op == "FONT":
		font = ' '.join (args[1:])
	elif op == "FONTBOUNDINGBOX": 
		width, height, xoff, yoff = map (int, args [1:5])
		origin = xoff, height + yoff
	elif op == "ENCODING":
		char = int (args[1])
		row = 0
		all[char] = height * [0,]
	elif op == "BBX":
		char_width, char_height, dx, dy = map (int, args [1:5])
		shift = origin[0] + dx
		row = origin[1] - char_height - dy
	elif char and len (op) == 2:
		all[char][row] = int (op, 16) >> shift
		row += 1

if font: 
	print """/* automatically generated on %s
 * from "%s" 
 */""" % (time.ctime(), font)

print "static int %s_width = %d;" % (name, width);
print "static int %s_descent = %d;" % (name, yoff);
print "static unsigned char %s [256][%d] = {" % (name, height);

empty = height * [0,]
for c in range (256):
	print " {",
	bits = all.get (c, empty)
	for r in range (height):
		print "0x%02x," % bits[r],
	print "},"
print "};";
