#! /usr/bin/env python

import sgmllib, re

class Parser (sgmllib.SGMLParser):
	def __init__ (self, data):
		sgmllib.SGMLParser.__init__ (self)
		self.cell = ''
		self.all = []
		# run!
		self.feed (data)

	def start_tr (self, args):
		self.row = []

	def end_tr (self):
		x = self.row[0].split (' ')
		xx = ['0x00', '0x00', '0x00']

		for i in range (len (x)):
			if x[i][:2]:
				xx[i] = '0x' + x[i][:2]
		self.all.append ('{%s, %s, %s, "%s"}' % \
				(xx[0], xx[1], xx[2], self.row[1]))
		
	def handle_data (self, data):
		self.cell += data

	def start_td (self, args):
		self.cell = ''

	def end_td (self):
		lines = self.cell.replace ('\r', '').split ('\n')
		cell = ''
		for line in lines:
			if not line: continue
			cell = line
			break

		self.row.append (cell)
		
parser = Parser (open ('scratch/sysex-ids.markup').read())
parser.all.sort()

print """/* automatic generation */
typedef struct {
	byte d0, d1, d2;
	const char * manufacturer;
} SysexID;

SysexID sysex_ids[] = {"""

for mfg in parser.all:
	print "\t%s," % mfg
print """\t{0xFF, 0xFF, 0xFF, "unknown"}""" 
print "};"
