#! /usr/bin/env python

import sys

file = open ("Exceptions.h", "w")

print >> file, \
"""/* THIS IS A GENERATED FILE -- EDIT '%s' INSTEAD. */

#ifndef _EXCEPTIONS_H_
#define _EXCEPTIONS_H_

class blewit 
: public std::exception
{
	public:
		PyObject * py_exc;
		char excuse [400]; /* no range checks done. */

		blewit (int _errno); 
		blewit (const char * s = ""); 
		blewit (const blewit &); 
		
		blewit & operator << (const char * s);

		blewit & operator << (int i);
		blewit & operator << (long long i);

		blewit & operator << (double d);
		blewit & operator << (void * v);
		blewit & operator << (Object * o);

		void operator = (const blewit &);

		virtual const char * what() const throw ()
			{
				return excuse;
			}

		void throw_at_python();
};

#define FL << " (" << __FILE__ << ":" << __LINE__ << ")"

""" % sys.argv[0]

import exceptions

for e in dir (exceptions):
	if e[0] == '_': continue
	
	print >> file, \
"""class %s
: public blewit
{
	public:
		%s (int _errno)
			: blewit (_errno)
			{
				py_exc = PyExc_%s;
			}

		%s (const char * s = 0)
			: blewit (s)
			{
				py_exc = PyExc_%s;
			}
};
""" % (e, e, e, e, e)

print >> file, \
"""
#endif /* _EXCEPTIONS_H_ */""";
